// pages/access/access.js
import httpRequestApi from '../../utils/APIRequest';
Page({

  /**
   * 页面的初始数据
   */
  data: {
    PhotoBoxInfo: {},
    likeStatus: false,
    avatar: ""
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    console.log(options)
    if(options.share && !wx.getStorageSync('uid')) {
      wx.reLaunch({
        url: '/pages/index/index?ind=0'
      })
      return false;
    }
    this.getPhoneBoxInfo(options.id);
  },

  getPhoneBoxInfo(uid){
    httpRequestApi.getPhotoBoxInfoById({ uid }).success((res) => {
      this.setData({
        PhotoBoxInfo: res.data.data,
        avatar: res.data.data.user.avatar
      })
    })
  },

  //预览图片
  preview: function ({ currentTarget }) {
    console.log(currentTarget)
    const imageUrl = [currentTarget.id];
    wx.previewImage({
      urls: imageUrl
    })
  },

  userLike: function ({ currentTarget }) {
    console.log(currentTarget)
    console.log(this.data.PhotoBoxInfo.isLike)
    if(!this.data.PhotoBoxInfo.isLike) {
      httpRequestApi.setPhotoBoxLike({ target: currentTarget.id }).success((res) => {
        this.setData({
          likeStatus: res.data.data
        })
        this.getPhoneBoxInfo(currentTarget.id);
      })
    }
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {
    return {
      title: '七彩童年',
      path: `pages/access/access?share=true`,
      success: function (res) {
        // 转发成功
        console.log("转发成功:" + JSON.stringify(res));
        // var shareTickets = res.shareTickets;
        // if (shareTickets.length == 0) {
        //   return false;
        // }
        // //可以获取群组信息
        // wx.getShareInfo({
        //   shareTicket: shareTickets[0],
        //   success: function (res) {
        //     console.log(res)
        //   }
        // })
      },
      fail: function (res) {
        // 转发失败
        console.log("转发失败:" + JSON.stringify(res));
      }
    }
  }
})